# Python nrfutil port to C programming language
* Secure DFU UART transport is supported.
* UART bit rate is 115200bps with 8-N-1 data format. RTS/CTS flow control is enabled. It is the same as nRF5 SDK DFU bootloader.
* The program takes the DFU package ZIP file generated by Python nrfutil.
* nrfutil v3.5.0 is referred to.

In Windows, Visual Studio Express for Desktop is the development platform for Win32 target.
Besides, a make file is prepared for MSYS2 environment. The build command is:

    make -f Makefile.win32

The Win32 command line example is:

    UartSecureDFU COM1 dfu_app_pkg.zip

In Linux, a GNU makefile is prepared to call GCC. The build command is:

    make

The Linux command line example is:

    ./UartSecureDFU ttyACM0 dfu_app_pkg.zip

The imported third party source code has liberal open source license. No need to open the source code for end products.

## ZIP

ZIP module is imported to unzip DFU package.

    https://github.com/kuba--/zip

## JSON parser

JSMN is imported for JSON parsing.

    https://github.com/zserge/jsmn
